<template>
  <mgl-map
    ref="map"
    container="markerListMap"
    :access-token="accessToken"
    :map-style="mapStyle"
    sprite="mapbox://sprites/mapbox/bright-v8"
    v-bind="computedBbox"
    :max-bounds="maxBounds"
    @load="handleLoad"
  >
    <slot />
  </mgl-map>
</template>

<script>
  import { MglMap } from 'vue-mapbox'
  import config from '../../../config'

  export default {
    name: 'MetrocheckMap',

    components: {
      MglMap,
    },

    props: {
      zoom: { default: 12, type: Number },
      bounds: { required: false, type: [Object, Array] },
      maxBounds: { required: false, type: Array, default: () => config.map.maxBounds },
    },

    data () {
      return {
        accessToken: config.map.mapboxToken,
        mapStyle: config.map.style,
        center: { lng: 4.3517103, lat: 50.8503396 },
      }
    },

    computed: {
      computedBbox: function () {
        const bounds = this.$props.bbox
          ? null
          : { center: this.center, zoom: this.zoom }

        console.log(bounds)
        return bounds
      },
    },

    methods: {
      handleFeatureLeave: function (e) {
        // console.debug('gonna emit feature-leave');
        return this.$emit('feature-leave', e)
      },
      // @todo: check for possible performance issues
      // Check to deactivate on mobile
      handleFeatureEnter: function (e) {
        // console.debug('gonna emit feature-enter. Received event %O', e)
        // Sometimes we have clusters
        if (Object.hasOwnProperty.call(e.features[0].properties, 'cluster') && e.features[0].properties.cluster && e.features[0].layer.source === 'points') {
          // console.debug('We are dealing with a cluster here')
          const clusterSource = e.target.getSource(e.features[0].layer.source)

          clusterSource.getClusterLeaves(e.features[0].properties.cluster_id, e.features[0].properties.point_count, 0, (err, aFeatures) => {
            if (err) { console.warn(err); return }
            const detailedFeatures = {
              features: [Object.assign({}, e.features[0], {
                properties: {
                  name_fr: aFeatures[0].properties.name_fr,
                  id: aFeatures.filter(f => f.properties.name_fr === aFeatures[0].properties.name_fr).map(f => f.properties.id),
                },
              })],
            }
            return this.$emit('feature-enter', Object.assign({}, e, detailedFeatures))
          })
        } else {
          return this.$emit('feature-enter', e)
        }
      },

      handleLoad: function ({ map, component }) {
        if (this.$props.bounds) {
          component.actions.fitBounds(this.$props.bounds, {
            padding: 20,
          })
        }
        map.loadImage(
          '/img/metro.png',
          function (error, image) {
            if (error) throw error
            map.addImage('metro2', image, { sdf: true })
          },
        )

        if (!this.$vuetify.breakpoint.mobile) {
          map.on('mouseenter', 'positions', this.handleFeatureEnter)
          map.on('mouseleave', 'positions', this.handleFeatureLeave)

          map.on('mouseenter', 'points', this.handleFeatureEnter)
          map.on('mouseleave', 'points', this.handleFeatureLeave)
        }
      },
    },
  }
</script>
